package net.npaka.blockgame;
import java.io.*;
import java.io.IOException;

public class DtTestPointDriver {
	
    //-------------------------------------------------------------------------
    //  DynamicTracar MaskCode
    //-------------------------------------------------------------------------
    static public final int DT_VARIABLE_BIT       =    0x02;                /* Variable MASK */
    static public final int DT_EVTTRG_BIT         =    0x08;                /* EventTrigger MASK */
    
    static public FileOutputStream	fo = null;
    
    static {
    	try{
    		fo = new FileOutputStream("/proc/dt10sdif");
    	}
    	catch(IOException e){
    	}
    }
    
	//-------------------------------------------------------------------------
    //  TestPoint InsertCode Method
    //-------------------------------------------------------------------------
    /* Normal TestPoint Method */
    static public final void DtTestPoint(int nBaseAddress, int nStepNumber){
    	TpBusOut( nBaseAddress, nStepNumber);
    }

    /* Performance TestPoint Method */
    static public final void DtTestPointIdle(int nIdleAddress, int nStepNumber){
        /* Call DynamicTracerDriver */
        TpBusOut(nIdleAddress, nStepNumber);
    }

    /* EventTrigger TestPoint Method */
    static public final void DtTestPointEventTrigger(int nBaseAddress, int nStepNumber, int theValue){
        /* Call DynamicTracerDriver */
        TpEventTrigger(nBaseAddress, theValue);
    }

    /* MemoryOutput TestPoint Method */
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, byte theValue, int nLength){
        /* Call DynamicTracerDriver */
        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
        nBaseAddress = DT_VARIABLE_BIT;
        nBaseAddress |= 1 << 8 ;		/* Size */
        TpBusOut( nBaseAddress , (int)(theValue & 0xffff));
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, char theValue, int nLength){
        /* Call DynamicTracerDriver */
        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
        nBaseAddress = DT_VARIABLE_BIT;
        nBaseAddress |= 2 << 8 ;		/* Size */
        TpBusOut( nBaseAddress , (int)(theValue & 0xffff));
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, short theValue, int nLength){
        /* Call DynamicTracerDriver */
        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
        nBaseAddress = DT_VARIABLE_BIT;
        nBaseAddress |= 2 << 8 ;		/* Size */
        TpBusOut( nBaseAddress , (int)(theValue & 0xffff));
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, int theValue, int nLength){
        /* Call DynamicTracerDriver */
        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
        nBaseAddress = DT_VARIABLE_BIT;
        nBaseAddress |= 4 << 8 ;		/* Size */
        TpBusOut( nBaseAddress , (int)(theValue & 0xffff));
        TpBusOut( nBaseAddress , (int)((theValue >> 16) & 0xffff));
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, long theValue, int nLength){
        /* Call DynamicTracerDriver */
        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
        nBaseAddress = DT_VARIABLE_BIT;
        nBaseAddress |= 8 << 8 ;		/* Size */
        TpBusOut( nBaseAddress , (int)(theValue & 0xffff));
        TpBusOut( nBaseAddress , (int)((theValue) >> 16 & 0xffff));
        TpBusOut( nBaseAddress , (int)((theValue) >> 32 & 0xffff));
        TpBusOut( nBaseAddress , (int)((theValue) >> 48 & 0xffff));
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, boolean theValue, int nLength){
        /* Call DynamicTracerDriver */
        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
        nBaseAddress = DT_VARIABLE_BIT;
        nBaseAddress |= 1 << 8 ;		/* Size */
        TpBusOut( nBaseAddress , theValue?0x0100:0x0000 );
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, byte[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	if( nLength > 0 ){
	        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
	        nBaseAddress = DT_VARIABLE_BIT;
	        nBaseAddress |= (1 * nLength) << 8 ;		/* Size */
    		for(int cnt = 0; cnt < nLength; cnt++){
		        TpBusOut( nBaseAddress , (int)(theValue[cnt] & 0xffff));
    		}
    	}
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, char[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	if( nLength > 0 ){
	        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
	        nBaseAddress = DT_VARIABLE_BIT;
	        nBaseAddress |= (2 * nLength) << 8 ;		/* Size */
        	for(int cnt = 0; cnt < nLength; cnt++){
		        TpBusOut( nBaseAddress , (int)(theValue[cnt] & 0xffff));
        	}
    	}
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, short[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	if( nLength > 0 ){
	        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
	        nBaseAddress = DT_VARIABLE_BIT;
	        nBaseAddress |= (2 * nLength) << 8 ;		/* Size */
	        TpBusOut( nBaseAddress , (int)(theValue & 0xffff));
    		for(int cnt = 0; cnt < nLength; cnt++){
    			TpBusOut( nBaseAddress , (int)(theValue[cnt] & 0xffff));
    		}
    	}
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, int[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	if( nLength > 0 ){
	        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
	        nBaseAddress = DT_VARIABLE_BIT;
	        nBaseAddress |= (4 * nLength) << 8 ;		/* Size */
    		for(int cnt = 0; cnt < nLength; cnt++){
		        TpBusOut( nBaseAddress , (int)(theValue[cnt] & 0xffff));
		        TpBusOut( nBaseAddress , (int)((theValue[cnt] >> 16) & 0xffff));
    		}
    	}
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, long[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	if( nLength > 0 ){
	        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
	        nBaseAddress = DT_VARIABLE_BIT;
	        nBaseAddress |= (8 * nLength) << 8 ;		/* Size */
    		for(int cnt = 0; cnt < nLength; cnt++){
		        TpBusOut( nBaseAddress , (int)(theValue[cnt] & 0xffff));
		        TpBusOut( nBaseAddress , (int)((theValue)[cnt] >> 16 & 0xffff));
		        TpBusOut( nBaseAddress , (int)((theValue)[cnt] >> 32 & 0xffff));
		        TpBusOut( nBaseAddress , (int)((theValue)[cnt] >> 48 & 0xffff));
    		}
    	}
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, boolean[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	if( nLength > 0 ){
	        TpBusOut( nBaseAddress | DT_VARIABLE_BIT , nStepNumber );		/* Memory Dump Start */ 
	        nBaseAddress = DT_VARIABLE_BIT;
	        nBaseAddress |= (1 * nLength) << 8 ;		/* Size */
    		for(int cnt = 0; cnt < nLength; cnt++){
		        TpBusOut( nBaseAddress , theValue[cnt]?0x0100:0x0000 );
    		}
    	}
    }

    /* Normal TestPoint Method */
    static public final void TpBusOut(int nAddress, int nData){
    	byte[] buff = new byte[4];
    	buff[0] = (byte)(nData >> 8);
    	buff[1] = (byte)(nData);
    	buff[2] = (byte)(nAddress >> 8);
    	buff[3] = (byte)(nAddress);
    	try{
        	fo.write(buff, 0, 4);
    	}
    	catch(IOException e){
    	}
    }

    /* EventTrigger TestPoint Method */
    static public final void TpEventTrigger(int nAddress, int nData){
        /* DynamicTracerDriver */
        TpBusOut( nAddress | DT_EVTTRG_BIT , (int)(nData & 0xfff) << 4);
    }

}

