/****************************************************************************/
/* Copyright (C) 2011, Heartland.Data.co.  All Rights Reserved.				*/
/*																			*/
/* Title	: DT10 Driver	[native]										*/
/* Author	: HLDC															*/
/****************************************************************************/
#include <string.h>
#include <fcntl.h>

/* ========== Parameter ========== */
#define		DT_VARIABLE_BIT			0x2	/* Variabe */
#define		DT_EVENTTRIGGER_MASK	0x8	/* EventTrigger */
/* ============================================ */

static int fh = 0;

void _TP_BusOut( unsigned int addr, unsigned int data )
{

	unsigned char buff[4];

	if( fh == 0 )
	{
		fh = open("/proc/dt10sdif",O_RDWR);
	}
	if( fh != 0 )
	{
		buff[0] = data >> 8;
		buff[1] = data ;
		buff[2] = addr >> 8;
		buff[3] = addr ;
		write( fh, buff, 4 );
	}
}

void _TP_MemoryOutput( unsigned int addr, unsigned int data, void *value, unsigned int size)
{
	int	i;
	unsigned char *p = value;

	/* Memory Dump Start */
	_TP_BusOut(addr | DT_VARIABLE_BIT, data);
	/* Memory Dump */
	if( size >= 256 ) size = 256;
	if (value) {
		for( i = 0; i < size; i += 2 ){
			data = p[i] ;
			if( (i + 1) < size ){
				data |= p[i+1] << 8;
			}
			addr = DT_VARIABLE_BIT ;		// Variable Bit
			if( i == 0 ){
				addr |= size << 8 ;			// Size
			}
			_TP_BusOut( addr, data );
		}
	}
	else{
		_TP_BusOut(addr, data);
	}
}

void _TP_EventTrigger( unsigned int addr, unsigned int dat)
{
	_TP_BusOut(addr | DT_EVENTTRIGGER_MASK, dat << 4);
}
